=== modified file 'src/com/goldencode/p2j/uast/ClassDefinition.java'
--- old/src/com/goldencode/p2j/uast/ClassDefinition.java	2021-03-23 11:42:56 +0000
+++ new/src/com/goldencode/p2j/uast/ClassDefinition.java	2021-04-15 14:18:30 +0000
@@ -1,5 +1,4 @@
 /*
-** Module   : ClassDefinition.java
 ** Abstract : defines the 4GL API for a class or interface definition
 **
 ** Copyright (c) 2007-2021, Golden Code Development Corporation.
@@ -100,6 +99,8 @@
 **     CA  20210305          For builtin OO method calls, save at the call the typelist for the target method
 **                           parameters.
 **     CA  20210318          Fixed conversion of extent() function/statement with builtin OO properties.
+**     GES 20210311          Rewrote exact and fuzzy method matching to support all data types and
+**                           overloading rules.  Fixed many latent problems.
 */
 
 /*
@@ -160,6 +161,7 @@
 import java.lang.reflect.*;
 import java.util.*;
 import java.util.function.*;
+import java.util.stream.*;
 import com.goldencode.ast.*;
 import com.goldencode.p2j.convert.*;
 import com.goldencode.p2j.convert.db.*;
@@ -189,11 +191,6 @@
 public class ClassDefinition
 implements ProgressParserTokenTypes
 {
-   /**
-    * Flag to indicate whether tracing is ON.
-    */
-   public static final boolean nowrapObjects = System.getProperty("nowrap.objects") != null;
-
    /** Data store identifier. */
    protected static enum DataStoreType { VAR, METHOD, TABLE, QRY, DATASET, DATASRC };
 
@@ -650,7 +647,7 @@
       this.interfaces = interfaces.isEmpty() ? null : Collections.unmodifiableSet(interfaces);
       this.parents = parents.isEmpty() 
                         ? null 
-                        : (ClassDefinition[]) parents.toArray(new ClassDefinition[0]);
+                        : parents.toArray(new ClassDefinition[0]);
    }
    
    /**
@@ -1413,12 +1410,11 @@
             {
                // this can happen if we are referencing this class via a USING from an USING defined
                // in this file... in this case, inherit the tempidx, but show an warning.
-               MemberData dat = defs.get(new SignatureKey(sig));
                
                // GES_TODO: re-enable this
                // System.out.printf("\nERROR: duplicate method definition!\n");
                // System.out.printf("EXISTING %s\n", dat.toString());
-               // System.out.printf("DUPLICATE %s\n at %s", mdat.toString(), node.dumpTree());
+               // System.out.printf("DUPLICATE %s\n at %s", prevMdat.toString(), node.dumpTree());
                
                // return;
             }
@@ -1461,17 +1457,17 @@
       if (node != null)
       {
          node.putAnnotation("name", name);
-         node.putAnnotation("return_type", new Long(type));
+         node.putAnnotation("return_type", (long) type);
          node.putAnnotation("signature", renderSignature(name, sig)); 
-         node.putAnnotation("access-mode", new Long(access));
-         node.putAnnotation("static", new Boolean(isStatic));
+         node.putAnnotation("access-mode", (long) access);
+         node.putAnnotation("static", isStatic);
          node.putAnnotation("oo-data-store", DataStoreType.METHOD.toString());
-         node.putAnnotation("tempidx", new Long(mTempIdx));
+         node.putAnnotation("tempidx", (long) mTempIdx);
          node.putAnnotation("tempidx-file", this.filename);
          
          if (extent != 0)
          {
-            node.putAnnotation("extent", new Long(extent));
+            node.putAnnotation("extent", (long) extent);
          }
          
          if (ret != null && ret.isAnnotation("qualified"))
@@ -1570,7 +1566,8 @@
       if (node != null)
       {
          // go ahead and annotate the chp_wrapper right now too
-         MemberData mdat = lookupMethodWorker(mname, signature, access, isStatic, internal, node);
+         MethodSearchResult found = lookupMethodWorker(mname, signature, access, isStatic, internal, node);
+         MemberData         mdat    = (found == null) ?  null : found.data;
          
          if (mdat != null)
          {
@@ -1593,14 +1590,14 @@
             }
             
             // the access mode won't necessarily be the same as that passed in
-            node.putAnnotation("access-mode", new Long(mdat.access));
-            node.putAnnotation("static", new Boolean(mdat.isStatic));
+            node.putAnnotation("access-mode", (long) mdat.access);
+            node.putAnnotation("static", mdat.isStatic);
             if (mdat.modes != null && !mdat.modes.isEmpty())
             {
                node.putAnnotation("param_modes", mdat.modes);
             }
             
-            node.putAnnotation("tempidx", new Long(mdat.tempIdx));
+            node.putAnnotation("tempidx", (long) mdat.tempIdx);
             node.putAnnotation("tempidx-file", mdat.container.filename);
             
             node.putAnnotation("found-in-cls", mdat.container.name);
@@ -1612,7 +1609,7 @@
             
             if (mdat.extent != 0)
             {
-               node.putAnnotation("extent", new Long(mdat.extent));
+               node.putAnnotation("extent", (long) mdat.extent);
             }
             
             if (mdat.container.builtin && !mdat.container.dotnet)
@@ -1625,7 +1622,7 @@
                }
             }
             
-            annotateCallSignature(node, signature, mdat.signature);
+            annotateCallSignature(node, signature, mdat.signature, found.getOverrides());
             node.putAnnotation("signature", renderSignature(mdat.name, mdat.signature));
             if (isBuiltIn())
             {
@@ -1658,19 +1655,9 @@
          }
          else
          {
-            // check if there are POLY arguments (BaseDataType signature); if so, mark this call
-            // with 'dynamic', so conversion rules can emit a dynamic call for it
-            boolean dynamic = false;
-            for (ParameterKey key : signature)
-            {
-               if ("BaseDataType".equals(key.type))
-               {
-                  dynamic = true;
-                  break;
-               }
-            }
-            
-            if (dynamic)
+            // dynamic cases will have a non-null result; this may be for table-handle parms, dataset-handle
+            // parms or POLY parms
+            if (found != null && found.isDynamic())
             {
                node.putAnnotation("dynamic", true);
                if (isStatic)
@@ -2426,15 +2413,11 @@
             {
                if (vdata.var.isProp())
                {
-                  String datatype = SymbolResolver.translateType(vdata.type, null);
-                  if ("object".equals(datatype))
-                  {
-                     datatype = String.format("object <? extends %s>", vdata.qname);
-                  }
-                  int extent = vdata.var.getExtent();
-                  String ext = extent == 0 
-                                 ? "" 
-                                 : "[" + (extent > 0 ? Integer.toString(extent) : "") +"]";
+                  String datatype = SymbolResolver.translateType(vdata.type, null, vdata.qname);
+                  
+                  
+                  int    extent = vdata.var.getExtent();
+                  String ext = (extent == 0) ? "" : "[" + (extent > 0 ? Integer.toString(extent) : "") +"]";
 
                   // add property methods
                   String[] prefixes = extent != 0 ? extPrefixes : propPrefixes;
@@ -2684,8 +2667,15 @@
     *           The OO_METH_* node whose parameters will be annotated.
     * @param    callSig
     *           The array of parameter types that is the method definition signature.
+    * @param    defSig
+    *           The array of parameter types that is the method definition signature.
+    * @param    overrides
+    *           Type overrides found by any fuzzy matching for this method.
     */
-   private void annotateCallSignature(Aast call, ParameterKey[] callSig, ParameterKey[] defSig)
+   private void annotateCallSignature(Aast           call,
+                                      ParameterKey[] callSig,
+                                      ParameterKey[] defSig,
+                                      String[]       overrides)
    {
       int idx = 0;
       
@@ -2884,14 +2874,13 @@
                      {
                         if (parm.getType() == PARAMETER)
                         {
-                           parm.putAnnotation("wrap_parameter", new Boolean(true));
+                           parm.putAnnotation("wrap_parameter", true);
                         }
                      }
-                     else if ((!nowrapObjects || !classname.startsWith("object<")) && 
+                     else if (!classname.startsWith("object<") && 
                               !classname.startsWith("jobject<"))
                      {
-                        // TODO: CA: what's the reas for nowrapObjects?
-                        parm.putAnnotation("wrap_parameter", Boolean.TRUE);
+                        parm.putAnnotation("wrap_parameter", true);
                      }
                      
                      parm.putAnnotation("classname", classname);
@@ -2977,7 +2966,6 @@
             {
                Iterator<MemberData> iter = defs.values().iterator();
                
-               outer:
                while (iter.hasNext())
                {
                   MemberData dat = checkAccessRights(iter.next(), access);
@@ -3047,47 +3035,56 @@
     * @return   Member data or <code>null</code> if no such variable or data
     *           member exists. 
     */
-   private MemberData lookupMethodWorker(String         name,
-                                         ParameterKey[] sig,
-                                         int            access,
-                                         boolean        isStatic,
-                                         boolean        internal,
-                                         Aast           node)
+   private MethodSearchResult lookupMethodWorker(String         name,
+                                                 ParameterKey[] sig,
+                                                 int            access,
+                                                 boolean        isStatic,
+                                                 boolean        internal,
+                                                 Aast           node)
    {
-      MemberData mdat = null;
+      MethodSearchResult result = null;
       
       synchronized (lock)
       {
-         mdat = exactMethodLookup(name, sig, access, isStatic, internal);
+         result = exactMethodLookup(name, sig, access, isStatic, internal);
 
-         if (mdat == null && !isStatic && internal)
+         if (result == null && !isStatic && internal)
          {
             // can't find an instance member, check for static
-            mdat = exactMethodLookup(name, sig, access, true, internal);
+            result = exactMethodLookup(name, sig, access, true, internal);
          }
          
-         if (mdat == null)
+         if (result == null)
          {
-            mdat = fuzzyMethodLookup(name, sig, access, isStatic, internal, node);
+            result = fuzzyMethodLookup(name, sig, access, isStatic, internal, node);
    
-            if (mdat == null && !isStatic && internal)
+            if (result == null && !isStatic && internal)
             {
                // can't find an instance member, check for static
-               mdat = fuzzyMethodLookup(name, sig, access, true, internal, node);
+               result = fuzzyMethodLookup(name, sig, access, true, internal, node);
             }
          }
       }
       
-      return mdat;
+      return result;
    }
    
    /**
-    * Find the named method based on an exact signature match. This method will search up the
-    * parent hierarchy (recursively) if no exact match is found in the current class.
+    * Find the named method based on an exact signature match. This method searches all methods in the
+    * parent hierarchy not just in the current class.  This search the hierarchy approach is needed so
+    * that some special exceptions can be honored:
+    * <p>
+    * <ul>
+    *    <li>If the caller does not specify a mode and there is an otherwise exact match, that method is
+    *        selected.  Buffers have no mode processing so this case is ignored for them.</li>
+    *    <li>A caller's table-handle or dataset-handle parameter which has an exact match is disallowed
+    *        if there are any alternatives with a table/dataset at that parameter AND that parameter type
+    *        is what determines that the signatures are different.</li>
+    * </ul>
     *
     * @param    name
     *           Resource name.
-    * @param    sig
+    * @param    caller
     *           Method call signature.
     * @param    access
     *           Access mode (<code>KW_PUBLIC</code>, <code>KW_PROTECTD</code> or
@@ -3100,56 +3097,220 @@
     *
     * @return   Resource found or <code>null</code> if no match exists.
     */
-   private MemberData exactMethodLookup(String         name,
-                                        ParameterKey[] sig,
-                                        int            access,
-                                        boolean        isStatic,
-                                        boolean        internal)
-   {
-      MemberData mdat = null;
-      
-      synchronized (lock)
-      {
-         Map<String, Map<SignatureKey, MemberData>> map = isStatic ? smethods : imethods;
-         
-         if (map != null)
-         {
-            Map<SignatureKey, MemberData> defs = map.get(name.toLowerCase());
-            
-            if (defs != null)
-            {
-               // exact signature match is based on the key lookup
-               mdat = checkAccessRights(defs.get(new SignatureKey(sig)), access);
-            }
-         }
-         
-         // ignore if the static/instance does not match
-         if (mdat != null && !((!isStatic && (!mdat.isStatic || internal)) ||
-                               (isStatic && mdat.isStatic)))
-         {
-            // clear our result
-            mdat = null;
-         }
-         
-         // only look up the parent hierarchy if we haven't got a match yet; static lookups only
-         // work for internal usage, non-static lookups always work
-         if (mdat == null && parents != null && (!isStatic || internal))
-         {
-            // change access mode since we aren't allowed to see private stuff in parent
-            int _access = (access == KW_PRIVATE) ? KW_PROTECTD : access;
-            
-            for (ClassDefinition parent : parents)
-            {
-               // recurse up inheritence hierarchy
-               mdat = parent.exactMethodLookup(name, sig, _access, isStatic, internal);
-               
-               if (mdat != null)
-                  break;
-            }
-         }
-      }
-      
-      return mdat;
+   private MethodSearchResult exactMethodLookup(final String         name,
+                                                final ParameterKey[] caller,
+                                                final int            access,
+                                                final boolean        isStatic,
+                                                final boolean        internal)
+   {
+      List<MatchMetrics> list = candidates(name, caller.length, access, isStatic, internal, false, null);
+      
+      // quick out if there are no possible matches
+      if (list.isEmpty())
+      {
+         return null;
+      }
+
+      final boolean[] ignore = new boolean[caller.length];
+      
+      Predicate<MatchMetrics> exactMatch = (mem) -> 
+      {
+         for (int i = 0; i < caller.length; i++)
+         {
+            if (!ignore[i] && !caller[i].equals(mem.data.signature[i]))
+            {
+               return false;
+            }
+         }
+          
+         return true;
+      };
+       
+      List<MatchMetrics> exact = list.stream().filter(exactMatch).collect(Collectors.toList());
+
+      Predicate<MatchMetrics> flexModeMatch = (mem) -> 
+      {
+         for (int i = 0; i < caller.length; i++)
+         {
+            if (!ignore[i])
+            {
+               if (caller[i].mode != null)
+               {
+                  if (!caller[i].equals(mem.data.signature[i]))
+                  {
+                     return false;
+                  }
+               }
+               else
+               {
+                  if (!caller[i].typeEquivalent(mem.data.signature[i]))
+                  {
+                     return false;
+                  }
+               }
+            }
+         }
+         
+         return true;
+      };
+      
+      MethodSearchResult result = null;
+      boolean       flex   = false;
+      
+      if (exact.isEmpty())
+      {
+         List<MatchMetrics> flexMode = list.stream().filter(flexModeMatch).collect(Collectors.toList());
+         
+         if (flexMode.size() == 1)
+         {
+            result = new MethodSearchResult(flexMode.get(0).data, null);
+            flex   = true;
+         }
+      }
+      else
+      {
+         if (exact.size() == 1)
+         {
+            result = new MethodSearchResult(exact.get(0).data, null);
+         }
+      }
+      
+      if (result != null)
+      {
+         // table-handle/dataset-handle matches are only valid when the only difference in signature is
+         // between a table/dataset and table-handle/dataset-handle
+
+         Iterator<MatchMetrics> iter = list.iterator();
+         
+         // calculate which parameters are both table-handles/dataset-handles and have conflicting
+         // signature (another signature that has a table/dataset in the same parameter position)
+         while (iter.hasNext())
+         {
+            MatchMetrics m = iter.next();
+            
+            for (int i = 0; i < caller.length; i++)
+            {
+               // quick iteration if we already know this parameter should be ignored 
+               if (ignore[i])
+                  continue;
+               
+               String type = m.data.signature[i].type;
+
+               if ("TABLE-HANDLE".equals(caller[i].type))
+               {
+                  if (type != null && type.startsWith("TEMP-TABLE"))
+                  {
+                     ignore[i] = true;
+                  }
+               }
+               else if ("DATASET-HANDLE".equals(caller[i].type))
+               {
+                  if (type != null && type.startsWith("DATA-SET "))
+                  {
+                     ignore[i] = true;
+                  }
+               }
+            }
+         }
+
+         // ignoring the conflicting parameters, can we still calculate find a unique match?
+         List<MatchMetrics> ignoreTH = list.stream()
+                                            .filter(flex ? flexModeMatch : exactMatch)
+                                            .collect(Collectors.toList());
+         if (ignoreTH.size() != 1)
+         {
+            result = null;
+         }
+      }
+      
+      return result;
+   }
+   
+   /**
+    * Remove any candidates from the list which do not match the caller's extent.  The following are
+    * possible matches:
+    * <p>
+    * <ul>
+    *    <li> Neither the caller nor the parameter definition have an extent specification.
+    *    <li> Both the caller and the parameter definition have an indeterminate extent.
+    *    <li> The caller has a fixed extent value and the parameter definition has the same fixed extent
+    *         value.
+    *    <li> The caller has a fixed extent value and the parameter definition has an indeterminate
+    *         extent.  This is a fuzzy match (all the above criteria are the same as exact matches). 
+    *
+    * @param    list
+    *           The list of candidates.
+    * @param    callerExtVal
+    *           Caller's extent value (-1 means indeterminate, 0 is scalar and any positive value is
+    *           the fixed extent).
+    * @param    idx
+    *           Parameter number being processed.
+    */
+   private void processExtentMatches(List<MatchMetrics> list, int callerExtVal, int idx)
+   {
+      Predicate<MatchMetrics> test = null;
+      Consumer<MatchMetrics>  mark = (m) -> m.extExact++;
+      
+      // no extent in caller
+      if (callerExtVal == 0)
+      {
+         // no extent in the parameter definition
+         test = (mem) -> mem.data.signature[idx].type.indexOf("[") == -1;
+         
+         // no marking needed here
+         mark = (m) -> {};
+      }
+      // indeterminate extent in caller
+      else if (callerExtVal == -1)
+      {
+         // indeterminate extent in the parameter definition
+         test = (mem) -> mem.data.signature[idx].type.indexOf("[") != -1 && 
+                         getExtent(mem.data.signature[idx].type) == -1;
+      }
+      // fixed extent in caller
+      else
+      {
+         test = (mem) -> 
+         {
+            int extIdx = mem.data.signature[idx].type.indexOf("[");
+            
+            if (extIdx != -1)
+            {
+               // the parameter definition is an extent
+               int parmExtVal = getExtent(mem.data.signature[idx].type);
+               
+               // fixed extents match exactly or the parm is indeterminate
+               return callerExtVal == parmExtVal || parmExtVal == -1;
+            }
+            else
+            {
+               // the parameter definition is NOT an extent
+               return false;
+            }
+         };
+
+         // this will only be used for where we already know extIdx != -1 above which means it is an
+         // extent at the parameter definition (it may be either fixed or indeterminate) 
+         mark = (mem) -> 
+         {
+            // the parameter definition is an extent
+            int parmExtVal = getExtent(mem.data.signature[idx].type);
+            
+            if (callerExtVal == parmExtVal)
+            {
+               // both are fixed extents match exactly
+               mem.extExact++;
+            }
+            else if (parmExtVal == -1) 
+            {
+               // or the parm is indeterminate
+               mem.extCvt++;
+            }
+         };
+      }
+      
+      list.removeIf(test.negate());
+      list.stream().forEach(mark);
    }
    
    /**
@@ -3206,6 +3367,87 @@
    }
    
    /**
+    * Check if there is only 1 possible match for the given predicate, if so then remove all candidates
+    * from the list except for that one possible match.
+    * 
+    * @param    list
+    *           The list to edit.
+    * @param    test
+    *           The predicate to test.
+    * @param    idx
+    *           The parameter index for error messages.
+    * @param    callerType
+    *           The caller type for error messages.
+    * @param    error
+    *           A location to store an error message for the caller.
+    */
+   private boolean allowIfOnlyOne(List<MatchMetrics>      list, 
+                                  Predicate<MatchMetrics> test,
+                                  int                      idx, 
+                                  String                   callerType,
+                                  String[]                 error)
+   {
+      boolean result = false;
+      
+      List<MatchMetrics> matches = list.stream().filter(test).collect(Collectors.toList());
+
+      int num = matches.size();
+
+      if (num == 1)
+      {
+         result = true;
+         matches.stream().forEach((m) -> m.cvt++);
+         list.removeIf(test.negate());
+      }
+      else if (num > 1)
+      {
+         error[0] = String.format("Ambiguous matches (%d) for parameter %d of type %s.",
+                               num,
+                               idx, 
+                               callerType);
+      }
+      else
+      {
+         error[0] = String.format("No possible matches for parameter %d of type %s.", idx, callerType);
+      }
+      
+      if (!result)
+      {
+         list.clear();
+      }
+      
+      return result;
+   }
+   
+   /**
+    * Remove any non-exact matches from the given list.
+    * 
+    * @param    list
+    *           The list to edit.
+    * @param    exactMatch
+    *           The test for an exact match.
+    *           
+    * @return   {@code true} if edits were made.
+    */
+   private boolean processExactMatches(List<MatchMetrics> list, Predicate<MatchMetrics> exactMatch)
+   {
+      // calculate the exact TYPE matches
+      List<MatchMetrics> exacts = list.stream().filter(exactMatch).collect(Collectors.toList());
+      
+      if (!exacts.isEmpty())
+      {
+         exacts.stream().forEach((m) -> m.exact++);
+         
+         // there is at least 1 exact match, remove everything else
+         list.removeIf(exactMatch.negate());
+         
+         return true;
+      }
+
+      return false;
+   }
+   
+   /**
     * Find the named method based on a fuzzy signature match. This method will search up the
     * parent hierarchy (recursively) if no fuzzy match is found in the current class.
     *
